

begin runonce
    cdecl function yaml_get_version_string lib "libyaml.dll" as string
    cdecl function yaml_parser_initialize lib "libyaml.dll" (ptr as long) as long
    cdecl sub yaml_token_delete lib "libyaml.dll" (ptr as long)
    cdecl sub yaml_parser_delete lib "libyaml.dll" (ptr as long)
    cdecl sub yaml_parser_set_input_string lib "libyaml.dll" (ptr as long, sinput as string, slen as long)
    cdecl sub yaml_parser_scan lib "libyaml.dll" (lpparser as long, lptoken as long)
    cdecl sub yaml_parser_parse lib "libyaml.dll" (lpparser as long, lpevent as long)
    cdecl sub yaml_event_delete lib "libyaml.dll" (lpevent as long)
end runonce    

    ' # TOKEN API
    CONST YAML_NO_TOKEN = 0
    CONST YAML_STREAM_START_TOKEN = 1
    CONST YAML_STREAM_END_TOKEN = 2
    CONST YAML_VERSION_DIRECTIVE_TOKEN =  3
    CONST YAML_TAG_DIRECTIVE_TOKEN = 4
    CONST YAML_DOCUMENT_START_TOKEN = 5
    CONST YAML_DOCUMENT_END_TOKEN = 6
    CONST YAML_BLOCK_SEQUENCE_START_TOKEN = 7
    CONST YAML_BLOCK_MAPPING_START_TOKEN = 8
    CONST YAML_BLOCK_END_TOKEN = 9
    CONST YAML_FLOW_SEQUENCE_START_TOKEN = 10
    CONST YAML_FLOW_SEQUENCE_END_TOKEN = 11
    CONST YAML_FLOW_MAPPING_START_TOKEN = 12
    CONST YAML_FLOW_MAPPING_END_TOKEN = 13
    CONST YAML_BLOCK_ENTRY_TOKEN = 14
    CONST YAML_FLOW_ENTRY_TOKEN =  15
    CONST YAML_KEY_TOKEN = 16
    CONST YAML_VALUE_TOKEN = 17
    CONST YAML_ALIAS_TOKEN = 18
    CONST YAML_ANCHOR_TOKEN = 19
    CONST YAML_TAG_TOKEN = 20
    CONST YAML_SCALAR_TOKEN = 21


    ' ## NOTE: WHEN USING EVENT API, EVENT STRUCT IS ROUGHLY 40 BYTES IN SIZE ##
    ' ## SO USING A STRING AND BYREF/BYREF$ ELIMINATES THE NEED FOR DEFINING A STRUCT/TYPE ##

    ' EVENT API
    CONST YAML_NO_EVENT = 0
    CONST YAML_STREAM_START_EVENT = 1
    CONST YAML_STREAM_END_EVENT = 2
    CONST YAML_DOCUMENT_START_EVENT = 3
    CONST YAML_DOCUMENT_END_EVENT = 4
    CONST YAML_ALIAS_EVENT = 5
    CONST YAML_SCALAR_EVENT = 6
    CONST YAML_SEQUENCE_START_EVENT = 7
    CONST YAML_SEQUENCE_END_EVENT = 8
    CONST YAML_MAPPING_START_EVENT = 9
    CONST YAML_MAPPING_END_EVENT = 10
